//+-----------------------------------------------------------------+
//|              ichimoku-tripla kumo moving settable        |
//+-----------------------------------------------------------------+
#property copyright "Copyright  2016 Fausto Puja"
#property link      "http://www.pelaccia"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 White
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Yellow
#property indicator_color6 Red
#property indicator_color7 Blue
#property indicator_color8 Yellow

//---- input parameters
extern int Tenkan=9;
extern int Kijun=30;
extern int Senkou=120;

extern int Tenkan1=9;
extern int Kijun1=35;
extern int Senkou1=150;

extern int Tenkan2=4;
extern int Kijun2=17;
extern int Senkou2=120;

extern color ColorKumo1 = Red;
extern color ColorKumo2 = Blue;
extern color ColorKumo3 = Yellow;

int shiftbar=0;
double shiftval=0;

int shiftbar1=0;
double shiftval1=0;

int shiftbar2=0;
double shiftval2=0;

//---- buffers
double Tenkan_Buffer[];
double Kijun_Buffer[];

double Tenkan1_Buffer[];
double Kijun1_Buffer[];

double Tenkan2_Buffer[];
double Kijun2_Buffer[];

double SpanA_Buffer[];
double SpanB_Buffer[];

//double Chinkou_Buffer[];
double SpanA1_Buffer[];
double SpanB1_Buffer[];

double SpanA2_Buffer[];
double SpanB2_Buffer[];
//----
int a_begin,a_begin1,a_begin2;
string Copyright="\xA9 PELACCIA CORP.";
string MPrefix="FI";


//****************************ROBA MIA******************************************

double Value_base = 0; //misura base del tick


// unique identifier that we can access from multiple places throughout the code
string sButtonUpFast = "up_fast";
string sButtonDoFast = "down_fast";
string sButtonRgFast = "right_fast";
string sButtonLfFast = "left_fast";
string sButtonUpSlow = "up_slow";
string sButtonDoSlow = "down_slow";
string sButtonRgSlow = "right_slow";
string sButtonLfSlow = "left_slow";

string sButtonUpFast1 = "up_fast1";
string sButtonDoFast1 = "down_fast1";
string sButtonRgFast1 = "right_fast1";
string sButtonLfFast1 = "left_fast1";
string sButtonUpSlow1 = "up_slow1";
string sButtonDoSlow1 = "down_slow1";
string sButtonRgSlow1 = "right_slow1";
string sButtonLfSlow1 = "left_slow1";

string sButtonUpFast2 = "up_fast2";
string sButtonDoFast2 = "down_fast2";
string sButtonRgFast2 = "right_fast2";
string sButtonLfFast2 = "left_fast2";
string sButtonUpSlow2 = "up_slow2";
string sButtonDoSlow2 = "down_slow2";
string sButtonRgSlow2 = "right_slow2";
string sButtonLfSlow2 = "left_slow2";


//******************************************************************************

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//----
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,Tenkan_Buffer);
   SetIndexDrawBegin(0,Tenkan-1);
   SetIndexLabel(0,"Tenkan Sen");
//----
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,Kijun_Buffer);
   SetIndexDrawBegin(1,Kijun-1);
   SetIndexLabel(1,"Kijun Sen");
   

   a_begin=Kijun;   if(a_begin<Tenkan)  a_begin=Tenkan;
   a_begin1=Kijun1; if(a_begin1<Tenkan1) a_begin1=Tenkan1;
   a_begin2=Kijun2; if(a_begin2<Tenkan2) a_begin2=Tenkan2;
   
   SetIndexStyle(2,DRAW_LINE,EMPTY,EMPTY,ColorKumo1);
   SetIndexBuffer(2,SpanA_Buffer);
   SetIndexDrawBegin(2,Kijun+a_begin-1);
   SetIndexShift(2,Kijun+shiftbar);
   SetIndexLabel(2,"Senkou Span A1");

   SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,ColorKumo2);
   SetIndexBuffer(3,SpanA1_Buffer);
   SetIndexDrawBegin(3,Kijun1+a_begin1-1);
   SetIndexShift(3,Kijun1+shiftbar1);
   SetIndexLabel(3,"Senkou Span A2");

   SetIndexStyle(4,DRAW_LINE,EMPTY,EMPTY,ColorKumo3);
   SetIndexBuffer(4,SpanA2_Buffer);
   SetIndexDrawBegin(4,Kijun2+a_begin2-1);
   SetIndexShift(4,Kijun2+shiftbar2);
   SetIndexLabel(4,"Senkou Span A3");
//----

   SetIndexStyle(5,DRAW_LINE,EMPTY,EMPTY,ColorKumo1);
   SetIndexBuffer(5,SpanB_Buffer);
   SetIndexDrawBegin(5,Kijun+Senkou-1);
   SetIndexShift(5,Kijun+shiftbar);
   SetIndexLabel(5,"Senkou Span B1");
   
   SetIndexStyle(6,DRAW_LINE,EMPTY,EMPTY,ColorKumo2);
   SetIndexBuffer(6,SpanB1_Buffer);
   SetIndexDrawBegin(6,Kijun1+Senkou1-1);
   SetIndexShift(6,Kijun1+shiftbar1);
   SetIndexLabel(6,"Senkou Span B2");
   
   SetIndexStyle(7,DRAW_LINE,EMPTY,EMPTY,ColorKumo3);
   SetIndexBuffer(7,SpanB2_Buffer);
   SetIndexDrawBegin(7,Kijun2+Senkou2-1);
   SetIndexShift(7,Kijun2+shiftbar2);
   SetIndexLabel(7,"Senkou Span B3");

/*
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Chinkou_Buffer);
   SetIndexShift(4,-Kijun);
   SetIndexLabel(4,"Chinkou Span");
*/


//*********************************ROBA MIA************************************
   // force the button to be drawn when the indicator is first placed on the chart
   //color cColor  = clrRed;
   //uchar ucArrow = 233;
   CreateButton(sButtonUpFast,ColorKumo1,"Wingdings",CharToStr(233),75,0);
   CreateButton(sButtonDoFast,ColorKumo1,"Wingdings",CharToStr(234),75,20);
   CreateButton(sButtonLfFast,ColorKumo1,"Wingdings",CharToStr(231),95,10);
   CreateButton(sButtonRgFast,ColorKumo1,"Wingdings",CharToStr(232),55,10);
   
   CreateButton(sButtonUpSlow,ColorKumo1,"Wingdings",CharToStr(225),75,40);
   CreateButton(sButtonDoSlow,ColorKumo1,"Wingdings",CharToStr(226),75,65);
   CreateButton(sButtonLfSlow,ColorKumo1,"Wingdings",CharToStr(223),95,50);
   CreateButton(sButtonRgSlow,ColorKumo1,"Wingdings",CharToStr(224),55,50);

   //cColor  = clrBlue;

   CreateButton(sButtonUpFast1,ColorKumo2,"Wingdings",CharToStr(233),175,0);
   CreateButton(sButtonDoFast1,ColorKumo2,"Wingdings",CharToStr(234),175,20);
   CreateButton(sButtonLfFast1,ColorKumo2,"Wingdings",CharToStr(231),195,10);
   CreateButton(sButtonRgFast1,ColorKumo2,"Wingdings",CharToStr(232),155,10);
   
   CreateButton(sButtonUpSlow1,ColorKumo2,"Wingdings",CharToStr(225),175,40);
   CreateButton(sButtonDoSlow1,ColorKumo2,"Wingdings",CharToStr(226),175,65);
   CreateButton(sButtonLfSlow1,ColorKumo2,"Wingdings",CharToStr(223),195,50);
   CreateButton(sButtonRgSlow1,ColorKumo2,"Wingdings",CharToStr(224),155,50);
   
   //cColor  = clrYellow;

   CreateButton(sButtonUpFast2,ColorKumo3,"Wingdings",CharToStr(233),275,0);
   CreateButton(sButtonDoFast2,ColorKumo3,"Wingdings",CharToStr(234),275,20);
   CreateButton(sButtonLfFast2,ColorKumo3,"Wingdings",CharToStr(231),295,10);
   CreateButton(sButtonRgFast2,ColorKumo3,"Wingdings",CharToStr(232),255,10);
   
   CreateButton(sButtonUpSlow2,ColorKumo3,"Wingdings",CharToStr(225),275,40);
   CreateButton(sButtonDoSlow2,ColorKumo3,"Wingdings",CharToStr(226),275,65);
   CreateButton(sButtonLfSlow2,ColorKumo3,"Wingdings",CharToStr(223),295,50);
   CreateButton(sButtonRgSlow2,ColorKumo3,"Wingdings",CharToStr(224),255,50);

/*
 Comment(" KUMO 1 ROSSA  - Shift Verticale (punti): ", DoubleToStr(shiftval,5),"   Shift Orizzontale (barre): ",shiftbar,
         "\n KUMO 2 BLU       - Shift Verticale (punti): ", DoubleToStr(shiftval1,5),"   Shift Orizzontale (barre): ",shiftbar1,
         "\n KUMO 3 GIALLA - Shift Verticale (punti): ", DoubleToStr(shiftval2,5),"   Shift Orizzontale (barre): ",shiftbar2);
*/ 

   ObjectCreate("Kumo1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Kumo1","KUMO "+ IntegerToString(Tenkan)+" "+IntegerToString(Kijun)+" "+IntegerToString(Senkou)+" - Shift Vert: "+ DoubleToStr(shiftval,5)+" Orizz: "+shiftbar,10, "Verdana", ColorKumo1);
   ObjectSet("Kumo1", OBJPROP_CORNER, 0);
   ObjectSet("Kumo1", OBJPROP_XDISTANCE, 200);
   ObjectSet("Kumo1", OBJPROP_YDISTANCE, 15);

   ObjectCreate("Kumo2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Kumo2","KUMO "+ IntegerToString(Tenkan1)+" "+IntegerToString(Kijun1)+" "+IntegerToString(Senkou1)+" - Shift Vert: "+ DoubleToStr(shiftval1,5)+" Orizz: "+shiftbar1,10, "Verdana", ColorKumo2);
   ObjectSet("Kumo2", OBJPROP_CORNER, 0);
   ObjectSet("Kumo2", OBJPROP_XDISTANCE, 200);
   ObjectSet("Kumo2", OBJPROP_YDISTANCE, 30);

   ObjectCreate("Kumo3", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Kumo3","KUMO "+ IntegerToString(Tenkan2)+" "+IntegerToString(Kijun2)+" "+IntegerToString(Senkou2)+" - Shift Vert: "+ DoubleToStr(shiftval2,5)+" Orizz: "+shiftbar2,10, "Verdana", ColorKumo3);
   ObjectSet("Kumo3", OBJPROP_CORNER, 0);
   ObjectSet("Kumo3", OBJPROP_XDISTANCE, 200);
   ObjectSet("Kumo3", OBJPROP_YDISTANCE, 45);



//********************************************************************************




   return(0);
  }
  
  
  
  
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ClearObjects(); 

   ObjectDelete(sButtonUpFast);
   ObjectDelete(sButtonDoFast);
   ObjectDelete(sButtonLfFast);
   ObjectDelete(sButtonRgFast);
   ObjectDelete(sButtonUpSlow);
   ObjectDelete(sButtonDoSlow);
   ObjectDelete(sButtonLfSlow);
   ObjectDelete(sButtonRgSlow);

   ObjectDelete(sButtonUpFast1);
   ObjectDelete(sButtonDoFast1);
   ObjectDelete(sButtonLfFast1);
   ObjectDelete(sButtonRgFast1);
   ObjectDelete(sButtonUpSlow1);
   ObjectDelete(sButtonDoSlow1);
   ObjectDelete(sButtonLfSlow1);
   ObjectDelete(sButtonRgSlow1);
   
   ObjectDelete(sButtonUpFast2);
   ObjectDelete(sButtonDoFast2);
   ObjectDelete(sButtonLfFast2);
   ObjectDelete(sButtonRgFast2);
   ObjectDelete(sButtonUpSlow2);
   ObjectDelete(sButtonDoSlow2);
   ObjectDelete(sButtonLfSlow2);
   ObjectDelete(sButtonRgSlow2);

   ObjectDelete("Kumo1");
   ObjectDelete("Kumo2");
   ObjectDelete("Kumo3");

   Comment("");
//**********************************
   return(0);
  }
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;


   if(Bars<=Tenkan || Bars<=Kijun || Bars<=Senkou || Bars<=Tenkan1 || Bars<=Kijun1 || Bars<=Senkou1 || Bars<=Tenkan2 || Bars<=Kijun2 || Bars<=Senkou2) return(0);


   ArrayResize(Tenkan1_Buffer,Bars);
   ArrayResize(Tenkan2_Buffer,Bars);
   ArrayResize(Kijun1_Buffer,Bars);
   ArrayResize(Kijun2_Buffer,Bars);
   ArraySetAsSeries(Tenkan1_Buffer,true);
   ArraySetAsSeries(Tenkan2_Buffer,true);
   ArraySetAsSeries(Kijun1_Buffer,true);
   ArraySetAsSeries(Kijun2_Buffer,true);

//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=Tenkan;i++)     Tenkan_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun;i++)      Kijun_Buffer[Bars-i]=0;
      for(i=1;i<=Tenkan1;i++)    Tenkan1_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun1;i++)     Kijun1_Buffer[Bars-i]=0;
      for(i=1;i<=Tenkan2;i++)    Tenkan2_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun2;i++)     Kijun2_Buffer[Bars-i]=0;
      
      for(i=1;i<=a_begin;i++)   SpanA_Buffer[Bars-i]=0;
      for(i=1;i<=a_begin1;i++)  SpanA1_Buffer[Bars-i]=0;
      for(i=1;i<=a_begin2;i++)  SpanA2_Buffer[Bars-i]=0; 
      
      for(i=1;i<=Senkou;i++)    SpanB_Buffer[Bars-i]=0;
      for(i=1;i<=Senkou1;i++)   SpanB1_Buffer[Bars-i]=0;
      for(i=1;i<=Senkou2;i++)   SpanB2_Buffer[Bars-i]=0;
     }

//*********************PRIMA KUMO*************************************

//---- Tenkan Sen 
   i=Bars-Tenkan;
   if(counted_bars>Tenkan) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Kijun Sen
   i=Bars-Kijun;
   if(counted_bars>Kijun) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijun_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Senkou Span A
   i=Bars-a_begin+1;
   if(counted_bars>a_begin-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      price=(Kijun_Buffer[i]+Tenkan_Buffer[i])/2;
      SpanA_Buffer[i]=price+shiftval;
      i--;
     }
//---- Senkou Span B
   i=Bars-Senkou;
   if(counted_bars>Senkou) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      price=(high+low)/2;
      SpanB_Buffer[i]=price+shiftval;
      i--;
     }
     
//*********************SECONDA KUMO*************************************

//---- Tenkan Sen 
   i=Bars-Tenkan1;
   if(counted_bars>Tenkan1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan1;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan1_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Kijun Sen
   i=Bars-Kijun1;
   if(counted_bars>Kijun1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun1;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijun1_Buffer[i]=(high+low)/2;
      i--;
     }

//---- Senkou Span A
   i=Bars-a_begin1+1;
   if(counted_bars>a_begin1-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      price=(Kijun1_Buffer[i]+Tenkan1_Buffer[i])/2;
      SpanA1_Buffer[i]=price+shiftval1;
      i--;
     }
//---- Senkou Span B
   i=Bars-Senkou1;
   if(counted_bars>Senkou1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou1;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      price=(high+low)/2;
      SpanB1_Buffer[i]=price+shiftval1;
      i--;
     }
     
     
//*********************TERZA KUMO*************************************

//---- Tenkan Sen 
   i=Bars-Tenkan2;
   if(counted_bars>Tenkan2) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan2;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan2_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Kijun Sen
   i=Bars-Kijun2;
   if(counted_bars>Kijun2) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun2;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijun2_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Senkou Span A
   i=Bars-a_begin2+1;
   if(counted_bars>a_begin2-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      price=(Kijun2_Buffer[i]+Tenkan2_Buffer[i])/2;
      SpanA2_Buffer[i]=price+shiftval2;
      i--;
     }
//---- Senkou Span B
   i=Bars-Senkou2;
   if(counted_bars>Senkou2) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou2;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      price=(high+low)/2;
      SpanB2_Buffer[i]=price+shiftval2;
      i--;
     }
          


//***************ROBA MIA****************************
/*   if((shiftbar!=shiftbar_memory)||(shiftval!=shiftval_memory)) 
   {
    
    ChartSetSymbolPeriod(0, NULL, M15 );
    //ClearObjects();
    //init();
    shiftval_memory=shiftval;
    value_y_memory=value_y;
   }
  */ 


   return(0);
   
  }




//+------------------------------------------------------------------+
//| ClearObjects function                                            |
//+------------------------------------------------------------------+
void ClearObjects() 
{ 
  for(int i=0;i<ObjectsTotal();i++) 
  if(StringFind(ObjectName(i),MPrefix)==0) { ObjectDelete(ObjectName(i)); i--; } 
}
//+------------------------------------------------------------------+





//**************************ROBA MIA*************************************
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {

   Value_base=MarketInfo(Symbol(), MODE_TICKSIZE);
   if (Value_base==0.01) Value_base=1;
   if (Value_base==0.001) Value_base=0.01;

// Frecce 1
   if(sparam==sButtonUpFast) shiftval=shiftval+Value_base*10;
   if(sparam==sButtonDoFast) shiftval=shiftval-Value_base*10;
   if(sparam==sButtonRgFast) shiftbar=shiftbar+10;
   if(sparam==sButtonLfFast) shiftbar=shiftbar-10;
   
   if(sparam==sButtonUpSlow) shiftval=shiftval+Value_base*1;
   if(sparam==sButtonDoSlow) shiftval=shiftval-Value_base*1;
   if(sparam==sButtonRgSlow) shiftbar=shiftbar+1;
   if(sparam==sButtonLfSlow) shiftbar=shiftbar-1;

// Frecce 2

   if(sparam==sButtonUpFast1) shiftval1=shiftval1+Value_base*10;
   if(sparam==sButtonDoFast1) shiftval1=shiftval1-Value_base*10;
   if(sparam==sButtonRgFast1) shiftbar1=shiftbar1+10;
   if(sparam==sButtonLfFast1) shiftbar1=shiftbar1-10;
   
   if(sparam==sButtonUpSlow1) shiftval1=shiftval1+Value_base*1;
   if(sparam==sButtonDoSlow1) shiftval1=shiftval1-Value_base*1;
   if(sparam==sButtonRgSlow1) shiftbar1=shiftbar1+1;
   if(sparam==sButtonLfSlow1) shiftbar1=shiftbar1-1;
   
// Frecce 3

   if(sparam==sButtonUpFast2) shiftval2=shiftval2+Value_base*10;
   if(sparam==sButtonDoFast2) shiftval2=shiftval2-Value_base*10;
   if(sparam==sButtonRgFast2) shiftbar2=shiftbar2+10;
   if(sparam==sButtonLfFast2) shiftbar2=shiftbar2-10;
   
   if(sparam==sButtonUpSlow2) shiftval2=shiftval2+Value_base*1;
   if(sparam==sButtonDoSlow2) shiftval2=shiftval2-Value_base*1;
   if(sparam==sButtonRgSlow2) shiftbar2=shiftbar2+1;
   if(sparam==sButtonLfSlow2) shiftbar2=shiftbar2-1;  


 //  Comment(" KUMO 1 ROSSA  - Shift Verticale (punti): ", DoubleToStr(shiftval,5),"   Shift Orizzontale (barre): ",shiftbar,
//       "\n KUMO 2 BLU       - Shift Verticale (punti): ", DoubleToStr(shiftval1,5),"   Shift Orizzontale (barre): ",shiftbar1,
 //       "\n KUMO 3 GIALLA - Shift Verticale (punti): ", DoubleToStr(shiftval2,5),"   Shift Orizzontale (barre): ",shiftbar2);

   ObjectSetText("Kumo1","KUMO "+ IntegerToString(Tenkan)+" "+IntegerToString(Kijun)+" "+IntegerToString(Senkou)+" - Shift Vert: "+ DoubleToStr(shiftval,5)+" Orizz: "+shiftbar,10, "Verdana", ColorKumo1);
   ObjectSetText("Kumo2","KUMO "+ IntegerToString(Tenkan1)+" "+IntegerToString(Kijun1)+" "+IntegerToString(Senkou1)+" - Shift Vert: "+ DoubleToStr(shiftval1,5)+" Orizz: "+shiftbar1,10, "Verdana", ColorKumo2);
   ObjectSetText("Kumo3","KUMO "+ IntegerToString(Tenkan2)+" "+IntegerToString(Kijun2)+" "+IntegerToString(Senkou2)+" - Shift Vert: "+ DoubleToStr(shiftval2,5)+" Orizz: "+shiftbar2,10, "Verdana", ColorKumo3);


   SetIndexShift(2,Kijun+shiftbar);
   SetIndexShift(5,Kijun+shiftbar);
   SetIndexShift(3,Kijun1+shiftbar1);
   SetIndexShift(6,Kijun1+shiftbar1);
   SetIndexShift(7,Kijun2+shiftbar2);
   SetIndexShift(4,Kijun2+shiftbar2);
  }






void CreateButton(string sName, color cColor, string sFont = "Wingdings", string sText = "", int xd = 0, int yd = 0)
{
// create a button on the chart
// many of these settings are hard coded below but you can easily have them as paramaters and pass them to the function
// just like I've done already with the color, font and text

   if(ObjectFind(sName)< 0){
      ObjectCreate(0,sName,OBJ_BUTTON,0,0,0);  
   }
   
   // these could be external valiables to allow the user to create the button wherever they wanted
   ObjectSetInteger(0,sName,OBJPROP_XDISTANCE,xd);
   ObjectSetInteger(0,sName,OBJPROP_YDISTANCE,yd);
   ObjectSetInteger(0,sName,OBJPROP_XSIZE,20);
   ObjectSetInteger(0,sName,OBJPROP_YSIZE,25);
   ObjectSetInteger(0,sName,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   
   ObjectSetInteger(0,sName,OBJPROP_HIDDEN,TRUE);
   
   ObjectSetString(0,sName,OBJPROP_TEXT,sText);
   ObjectSetInteger(0,sName,OBJPROP_COLOR, cColor);
   // I'm setting the background and border to the same as the chart background
   // as I'm just using a wingding arrow
   long result;

   result=ChartGetInteger(0,CHART_COLOR_BACKGROUND,0);

   color cBack = (color) result;

   ObjectSetInteger(0,sName,OBJPROP_BGCOLOR, cBack);

   ObjectSetInteger(0,sName,OBJPROP_BORDER_COLOR,cBack);
   // make sure our object shows up in the 'Objects List'
   ObjectSetInteger(0,sName,OBJPROP_HIDDEN, false);
   // commmented out some settings as they are not used
   // I would have normally deleted them but left them for completeness
   //ObjectSetInteger(0,sName,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   //ObjectSetInteger(0,sName,OBJPROP_STATE,false);
   ObjectSetString(0,sName,OBJPROP_FONT,sFont);
   ObjectSetInteger(0,sName,OBJPROP_FONTSIZE,14);
   
}
